/****************************************************************************
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2016-2021                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef PEARL_UTILS_H
    #error "Do not include this file!  Use <pearl/Utils.h> instead."
#endif


namespace pearl
{
// --- String manipulation --------------------------------------------------

inline std::string
trim(const std::string& value)
{
    const char* const WHITESPACE = " \f\n\r\t\v";

    std::string::size_type startpos = value.find_first_not_of(WHITESPACE);
    if (startpos == std::string::npos)
    {
        return std::string();
    }
    std::string::size_type endpos = value.find_last_not_of(WHITESPACE);

    return std::string(value, startpos, endpos - startpos + 1);
}
}    // namespace pearl
