/****************************************************************************
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2022                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2013                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


/*-------------------------------------------------------------------------*/
/**
 *  @file
 *  @brief Implementation of the class Pattern.
 *
 *  This file provides the implementation of the class Pattern.
 **/
/*-------------------------------------------------------------------------*/


#include <config.h>

#include "Pattern.h"

#include "Patterns_gen.h"

using namespace std;
using namespace scout;


// --- Symbolic names -------------------------------------------------------

#define PATTERNS_URL    "@mirror@scalasca_patterns.html#"


// --- Constructors & destructor --------------------------------------------

Pattern::~Pattern()
{
}


// --- Callback registration ------------------------------------------------

void
Pattern::registerCallbacks(CallbackManagerMap& cbmanagers)
{
    init();
}


// --- Pattern information access -------------------------------------------

long
Pattern::getParent() const
{
    return PAT_NONE;
}


string
Pattern::getDocumentationUrl() const
{
    return (PATTERNS_URL + getUniqueName());
}


bool
Pattern::isVisible() const
{
    return true;
}


// --- Pattern data management (protected) ----------------------------------

void
Pattern::init()
{
}
