/****************************************************************************
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2017-2021                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#include <config.h>

#include <pearl/Utils.h>

#include <string>

#include <gtest/gtest.h>

using namespace std;
using namespace testing;
using namespace pearl;


namespace
{
// --- trim tests -----------------------------------------------------------

TEST(trimT,
     trim_emptyString_returnsEmptyString)
{
    string expected;

    EXPECT_EQ(trim(string()), expected);
}


TEST(trimT,
     trim_whitespaceOnly_returnsEmptyString)
{
    string expected;

    EXPECT_EQ(trim(string(" \f\n\r\t\v")), expected);
}


TEST(trimT,
     trim_leadingWhitespace_returnsTrailingText)
{
    string expected("Some Text.");

    EXPECT_EQ(trim(string(" \v\t\f Some Text.")), expected);
}


TEST(trimT,
     trim_trailingWhitespace_returnsLeadingText)
{
    string expected("Some Text.");

    EXPECT_EQ(trim(string("Some Text.\n \r ")), expected);
}


TEST(trimT,
     trim_leadingAndTrailingWhitespace_returnsText)
{
    string expected("Some Text.");

    EXPECT_EQ(trim(string(" \v\t\f Some Text.\n \r ")), expected);
}
}    // unnamed namespace
